package net.ihe.gazelle.proxy.factory;

import net.ihe.gazelle.proxy.listeners.DicomEventListener;
import net.ihe.gazelle.proxy.netty.ChannelType;
import net.ihe.gazelle.proxy.netty.ConnectionConfig;
import net.ihe.gazelle.proxy.netty.Proxy;
import net.ihe.gazelle.proxy.netty.ProxyFactory;
import net.ihe.gazelle.proxy.netty.protocols.dicom.DicomProxy;
import net.ihe.gazelle.proxy.util.Preferences;

public class DicomProxyFactory implements ProxyFactory {

	@Override
	public Proxy<?, ?> newProxy(ConnectionConfig connectionConfig) {
		DicomEventListener proxyEventListener = new DicomEventListener();
		String storageDicom = Preferences.getProperty("storage.dicom");
		return new DicomProxy(proxyEventListener, connectionConfig, storageDicom);
	}

	@Override
	public ChannelType getChannelType() {
		return ChannelType.DICOM;
	}

}
