package net.ihe.gazelle.proxy.gui;

import javax.faces.context.FacesContext;

import net.ihe.gazelle.common.filter.HibernateDataModel;
import net.ihe.gazelle.hql.HQLQueryBuilder;
import net.ihe.gazelle.proxy.dao.MessageFilter;
import net.ihe.gazelle.proxy.model.message.AbstractMessage;

public class HibernateMessageDataModel<T extends AbstractMessage> extends HibernateDataModel<T> {

	private MessageFilter<T> messageFilter;

	public HibernateMessageDataModel(MessageFilter<T> messageFilter) {
		super(AbstractMessage.class);
		this.messageFilter = messageFilter;
	}

	@Override
	protected void appendFilters(FacesContext context, HQLQueryBuilder<T> queryBuilder) {
		super.appendFilters(context, queryBuilder);
		messageFilter.appendFilters(queryBuilder);
	}

}
