package net.ihe.gazelle.proxy.listeners;

import javax.persistence.EntityManager;

import net.ihe.gazelle.proxy.model.message.AbstractMessage;
import net.ihe.gazelle.proxy.model.message.Connection;
import net.ihe.gazelle.proxy.netty.ProxyEventListener;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public abstract class GazelleProxyEventListener<REQU, RESP> implements ProxyEventListener<REQU, RESP> {

	private static Logger log = LoggerFactory.getLogger(GazelleProxyEventListener.class);

	public GazelleProxyEventListener() {
		super();
	}

	public void processMessage(EntityManager entityManager, AbstractMessage abstractMessage, Integer requestChannelId,
			Integer responseChannelId) {
		if (abstractMessage.getConnection() == null) {
			Connection connection = ConnectionManager.retrieveConnection(entityManager, requestChannelId,
					responseChannelId);
			abstractMessage.setConnection(connection);
		}
		if (abstractMessage.getId() == null) {
			entityManager.persist(abstractMessage);
		} else {
			entityManager.merge(abstractMessage);
		}
	}

}
