/*
message * Copyright 2009 IHE International (http://www.ihe.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.ihe.gazelle.proxy.model.message;

import java.sql.Timestamp;

import javax.persistence.Entity;

import net.ihe.gazelle.proxy.netty.ChannelType;
import net.ihe.gazelle.proxy.netty.channel.ProxySide;

import org.jboss.seam.annotations.Name;

@Entity
@Name("hl7Message")
public class HL7Message extends AbstractMessage implements java.io.Serializable {

	private static final long serialVersionUID = 1417618530596352149L;

	public HL7Message() {
		super();
	}

	public HL7Message(Timestamp timestamp, String fromIP, Integer localPort, Integer proxyPort, String toIP,
			Integer remotePort, ProxySide proxySide) {
		super(timestamp, fromIP, localPort, proxyPort, toIP, remotePort, proxySide);
	}

	public ChannelType getChannelType() {
		return ChannelType.HL7;
	}

}
