package net.ihe.gazelle.proxy.util;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class Preferences {

	private static Properties preferences;
	private static Object preferencesSync = new Object();

	private Preferences() {
		super();
		// private!
	}

	public static String getProperty(String key) {
		return getPreferences().getProperty(key);
	}

	private static Properties getPreferences() {
		if (preferences == null) {
			synchronized (preferencesSync) {
				if (preferences == null) {
					preferences = new Properties();
					InputStream preferencesStream = Preferences.class.getResourceAsStream("/prefs.properties");
					try {
						preferences.load(preferencesStream);
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
		}
		return preferences;
	}

}
